package evaluation;

import java.io.File;
import java.util.List;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

import evaluation.models.EvaluationModel;


public class Evaluation {
	public static String selectStr = "Select the part you are doing:";


	// The number of evaluation part which is doing
	public static int curPartNum;

	// The number of current evaluation set
	private static int curSetNum = 0;

	// The number of total evaluation sets
	private static int totalSetsNum = 0;

	private static int curEvalType;

	public static JFrame chooseFrame = new JFrame();
	
	public EvaluationModel model = null;

	public static int getCurSetNum() {
		return curSetNum;
	}

	public static int getTotalSetsNum() {
		return totalSetsNum;
	}

	public static int getCurEvalType() {
		return curEvalType;
	}

	public static void main(String[] argv) throws Exception {
		JFileChooser chooser = new JFileChooser("./resources");
	    chooser.setFileFilter(new XmlFilter());

	    int returnVal = chooser.showOpenDialog(null);
	    if(returnVal != JFileChooser.APPROVE_OPTION) {
	      System.exit(0);
	    }
	    String modelsFile = chooser.getSelectedFile().getAbsolutePath();
//		String modelsFile = "./resources/model.xml";
		List models = EvaluationModel.modelsFromFile(modelsFile);
		Object[] partNames = EvaluationModel.getModelNames(models);
		Object selectedValue = JOptionPane.showInputDialog(null, selectStr,
				"The evaluation parts", JOptionPane.INFORMATION_MESSAGE, null,
				partNames, partNames[0]);
		if (selectedValue == null) {
			System.exit(0);
		}
		int partNum = -1;
		for (int i = 0; i < partNames.length; i++) {
			if (selectedValue.toString().endsWith(partNames[i].toString())) {
				partNum = i;
			}
		}
		
		((EvaluationModel)models.get(partNum)).startEvaluation();
	}








}

class XmlFilter extends FileFilter {

	    //Accept all directories and all gif, jpg, tiff, or png files.
	    public boolean accept(File f) {
	        if (f.isDirectory()) {
	            return true;
	        }

	        String extension = getExtension(f);
	        if (extension != null) {
	            if (extension.equalsIgnoreCase("xml")) {
	                    return true;
	            } else {
	                return false;
	            }
	        }

	        return false;
	    }

	    //The description of this filter
	    public String getDescription() {
	        return "XML files";
	    }
	    
	    private static String getExtension(File f) {
	        String ext = null;
	        String s = f.getName();
	        int i = s.lastIndexOf('.');

	        if (i > 0 &&  i < s.length() - 1) {
	            ext = s.substring(i+1).toLowerCase();
	        }
	        return ext;
	    }

	
}
