package evaluation.models;

import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.JOptionPane;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import evaluation.Question;
import evaluation.ui.ObjEvaluationWindow;
import evaluation.utils.XMLUtils;

public class ObjEvaluationModel extends EvaluationModel {
	private static final String displayTimeStr = "DisplayTime";
	private int displayTime = -1;
	public void startEvaluation() {
		showInstruction(instruction);
		judge = getCurrentJudge();
		try {
			ObjEvaluationWindow ow = new ObjEvaluationWindow(this);
		} catch (Exception e) {
			// e.printStackTrace();
			JOptionPane.showConfirmDialog(null,
					"Can't create the evaluation window!");
			System.exit(-1);
		}
	}



	public LinkedList getCurQuestions() {
		String name = judge.getCurPresentationName();
		LinkedList curQuestions = new LinkedList();
		Iterator it = questions.iterator();
		while (it.hasNext()) {
			Question curQuestion = (Question) it.next();

			if (curQuestion.getFileName() == null
					|| curQuestion.getFileName().equalsIgnoreCase(name)) {
				curQuestions.add(curQuestion);
			}
		}
		return curQuestions;
	}
	
	protected void updateFromDomNode(Node node) throws Exception {
		int type = node.getNodeType();

		switch (type) {
		case Node.DOCUMENT_NODE: {
			throw new Exception("Bad model file format:" + node.toString());
		}
		case Node.ELEMENT_NODE: {

			String nodeName = node.getNodeName();

			if (nodeName.equalsIgnoreCase(questionsStr)) {

				if (node.hasChildNodes()) {
					NodeList children = node.getChildNodes();
					for (int i = 0; i < children.getLength(); i++) {
						Question curQuestion = Question.fromDomNode(children
								.item(i));
						if (curQuestion != null) {
							questions.add(curQuestion);
						}
					}

				}
			} else if (nodeName.equalsIgnoreCase(pathStr)) {
				dataPath = XMLUtils.getText(node);
			} else if (nodeName.equalsIgnoreCase(nameStr)) {
				name = XMLUtils.getText(node);
			} else if (nodeName.equalsIgnoreCase(instructionStr)) {
				instruction = XMLUtils.getText(node);
			} else if (nodeName.equalsIgnoreCase(displayTimeStr)) {
				String timeStr = XMLUtils.getText(node);
				displayTime = Integer.parseInt(timeStr);
			} 
		}
		}

	}

	public int getDisplayTime() {
		return displayTime;
	}
	
}
