package evaluation.models;

import java.util.LinkedList;

import javax.swing.JOptionPane;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import evaluation.Question;
import evaluation.ui.SubEvaluationWindow;
import evaluation.utils.XMLUtils;

public class SubEvaluationModel extends EvaluationModel {
	

	/**
	 * @return Returns the questions.
	 */
	public LinkedList getQuestions() {
		return questions;
	}
	
	public void startEvaluation() {
		showInstruction(instruction);
		judge = getCurrentJudge();

		// totalSetsNum = subDirList.length;

		try {
			SubEvaluationWindow ew = new SubEvaluationWindow(this);
		} catch (Exception e) {
			// e.printStackTrace();
			JOptionPane.showConfirmDialog(null,
					"Can't create the evaluation window!");
			System.exit(-1);
		}
	}



	protected void updateFromDomNode(Node node) throws Exception {
		int type = node.getNodeType();

		switch (type) {
		case Node.DOCUMENT_NODE: {
			throw new Exception("Bad model file format:" + node.toString());
		}
		case Node.ELEMENT_NODE: {

			String nodeName = node.getNodeName();

			if (nodeName.equalsIgnoreCase(questionsStr)) {

				if (node.hasChildNodes()) {
					NodeList children = node.getChildNodes();
					for (int i = 0; i < children.getLength(); i++) {
						Question curQuestion = Question.fromDomNode(children
								.item(i));
						if (curQuestion != null) {
							questions.add(curQuestion);
						}
					}

				}
			} else if (nodeName.equalsIgnoreCase(pathStr)) {
				dataPath = XMLUtils.getText(node);
			} else if (nodeName.equalsIgnoreCase(nameStr)) {
				name = XMLUtils.getText(node);
			} else if (nodeName.equalsIgnoreCase(instructionStr)) {
				instruction = XMLUtils.getText(node);
			} 
		}
		}

	}



}
