package evaluation.ui;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JButton;

class ImageButton extends JButton
{
    private int width;
    private int height;
    //Indicate whether the button was selected
    private boolean selected = false;

    public ImageButton(File file, String text)
    {
	try {
	    image = ImageIO.read(file);
	    Dimension screenSize = getToolkit().getScreenSize();
	    width = screenSize.width/3;
	    height = screenSize.height/3;
	    //System.out.println("width: " + width + " height:" + height);
	    setSize(width, height);
	    setText(text);
	}
	catch (IOException exception) {
	    exception.printStackTrace();
	}
    }
    
    public void setSelected() {
	selected = true;
    }

    public boolean isSelected() {
	return selected;
    }

    public void paintComponent(Graphics g)
    {
	super.paintComponent(g);

	if (image == null) return;
	//image.setWidth(width);
	//image.setHeight(height);

	// draw the image in the upper-left corner
	if (!selected) {
	    g.drawImage(image, 0, 0, width, height, null);
	}
	else {
	   g.drawImage(image, 0, 0, (int)(width*0.3), (int)(height*0.3), null); 
	}
	//System.out.println("Drawing");
	// tile the image across the panel
	/*
	for (int i = 0; i * width <= getWidth(); i++)
	    for (int j = 0; j * height <= getHeight(); j++)
		if (i + j > 0)
		    g.copyArea(0, 0, width, height,
			       i * width, j * height);
	*/
    }
    
    private Image image;
}
