package evaluation.ui;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.event.MouseListener;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.JPanel;

class ImagePanel extends JPanel {
	public static int horizontalLineNum = 4;

	public static int verticalLineNum = 4;

	private boolean isTagging = false;

	private int width;

	private int height;

	private Image image;

	double subRatio = 0.75;

	double objRatio = 0.9;

	public ImagePanel(File file) {
		try {
			double ratio = subRatio;
			
			image = ImageIO.read(file);
			setLayout(new GridLayout(1, 1));
			Dimension screenSize = getToolkit().getScreenSize();
			width = (int) (ratio * screenSize.width);
			height = (int) (ratio * screenSize.height);
			// width = getWidth();
			// height = getHeight();
			int imageWidth = image.getWidth(null);
			int imageHeight = image.getHeight(null);
			width = height * imageWidth / imageHeight;
			// setSize(width, height);
		} catch (IOException exception) {
			exception.printStackTrace();
		}
	}

	public ImagePanel(File file, MouseListener listener) {
		try {
			double ratio = subRatio;
			image = ImageIO.read(file);
			setLayout(new GridLayout(1, 1));
			Dimension screenSize = getToolkit().getScreenSize();
			width = (int) (ratio * screenSize.width);
			height = (int) (ratio * screenSize.height);
			// width = getWidth();
			// height = getHeight();
			int imageWidth = image.getWidth(null);
			int imageHeight = image.getHeight(null);
			width = height * imageWidth / imageHeight;
			// setSize(width, height);
			addMouseListener(listener);
		} catch (IOException exception) {
			exception.printStackTrace();
		}
	}

	public ImagePanel(File file, MouseListener listener, boolean isTagging) {
		try {
			double ratio = subRatio;
			image = ImageIO.read(file);
			setLayout(new GridLayout(1, 1));
			Dimension screenSize = getToolkit().getScreenSize();
			width = (int) (ratio * screenSize.width);
			height = (int) (ratio * screenSize.height);
			// width = getWidth();
			// height = getHeight();
			int imageWidth = image.getWidth(null);
			int imageHeight = image.getHeight(null);
			width = height * imageWidth / imageHeight;
			// setSize(width, height);
			addMouseListener(listener);
		} catch (IOException exception) {
			exception.printStackTrace();
		}
	}

	public int getWidth() {
		if (width < image.getWidth(null)) {
			return width;
		} else {
			return image.getWidth(null);
		}
	}

	public int getHeight() {
		if (height < image.getHeight(null)) {
			return height;
		} else {
			return image.getHeight(null);
		}
	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);

		if (image == null)
			return;

		// draw the image in the upper-left corner
		if ((width > image.getWidth(null) && height > image.getHeight(null))) {
			g.drawImage(image, 0, 0, null);
			if (isTagging) {
				drawLines(g, image.getWidth(null), image.getHeight(null));
			}
		} else {
			g.drawImage(image, 0, 0, width, height, null);
			if (isTagging) {
				drawLines(g, width, height);
			}
		}
	}

	private void drawLines(Graphics g, int width, int height) {
		// Draw the horizontal lines
		for (int i = 0; i < horizontalLineNum; i++) {
			g.drawLine(0, height * (i + 1) / (horizontalLineNum + 1), width,
					height * (i + 1) / (horizontalLineNum + 1));
		}
		// Draw the vertical lines
		for (int i = 0; i < verticalLineNum; i++) {
			g.drawLine(width * (i + 1) / (verticalLineNum + 1), 0, width
					* (i + 1) / (verticalLineNum + 1), height);
		}
	}

}
