package evaluation.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.File;
import java.io.IOException;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;

import evaluation.models.SubEvaluationModel;

public class SubEvaluationBrowserWindow extends JFrame implements
		ActionListener, WindowListener {
	private SubQuestionPanel questionPanel;


	public SubEvaluationBrowserWindow(File file, SubEvaluationModel model)
			throws IOException {
		super("Selected File");
		JLabel text = new JLabel(
				"Indicate your degree of agreement with the following statements. When you are done, close this window.");
		text.setFont(new Font("Serif", Font.BOLD, 14));
		getContentPane().add(text, BorderLayout.NORTH);

		ImagePanel imagePanel = new ImagePanel(file);
		getContentPane().add(imagePanel);
		questionPanel = new SubQuestionPanel(model);
		getContentPane().add(questionPanel, BorderLayout.SOUTH);

		Dimension screenSize = getToolkit().getScreenSize();
		int width = screenSize.width * 8 / 10;
		int height = screenSize.height * 8 / 10;
		setBounds(width / 8, height / 8, width, height);
		setVisible(true);
		setExtendedState(Frame.MAXIMIZED_BOTH);
		setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
		addWindowListener(this);
		validate();
	}

	public void actionPerformed(ActionEvent e) {
		//String command = e.getActionCommand();
		// System.out.println("+++++++++" + command);
	}

	public void windowClosing(WindowEvent e) {
		
		if (!questionPanel.allAnswered()) {
			JOptionPane.showMessageDialog(null,
					"You must answer all questions.", "Error",
					JOptionPane.ERROR_MESSAGE);
		} else {
			questionPanel.storeAnswers();
			dispose();
		}
	}

	public void windowClosed(WindowEvent e) {

	}

	public void windowOpened(WindowEvent e) {

	}

	public void windowIconified(WindowEvent e) {

	}

	public void windowDeiconified(WindowEvent e) {

	}

	public void windowActivated(WindowEvent e) {

	}

	public void windowDeactivated(WindowEvent e) {

	}

	public void windowGainedFocus(WindowEvent e) {

	}

	public void windowLostFocus(WindowEvent e) {

	}

	public void windowStateChanged(WindowEvent e) {

	}

}
